"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const curry_1 = require("./curry");
const NOTHING = Symbol('nothing');
/**
 * Perform an operation with the previous value returned
 * @param withFn :: (a -> *)
 * @param fn: (...* -> a)
 * @returns (...* -> a)
 */
exports.withPrevious = curry_1.curry(function withPrevious(withFn, fn) {
    let previous = { [NOTHING]: true };
    return (...args) => {
        if (!isNothing(previous)) {
            withFn(previous.value);
        }
        const value = fn(...args);
        previous = { [NOTHING]: false, value };
        return value;
    };
});
function isNothing(maybe) {
    return maybe[NOTHING];
}
//# sourceMappingURL=withPrevious.js.map